/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.wahlvorschlag.boundary;

import de.ivu.elect.business.wahlvorschlag.entity.Direktkandidat;

@javax.enterprise.context.ApplicationScoped // ELECT-7845
public class DirektkandidatDAO extends AbstractDirektkandidatDAO {

  private static final long serialVersionUID = 1L;

  @javax.inject.Inject
  private transient de.ivu.elect.jee.entity.SimpleDAO simpleDAO;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return simpleDAO.getEntityManager();
  }

  public void persist(Direktkandidat direktkandidat){
    getEntityManager().persist(direktkandidat);
  }

  public void remove(Direktkandidat direktkandidat){
    getEntityManager().remove(direktkandidat);
  }

@javax.inject.Inject
private transient de.ivu.elect.presentation.system.DAOCache daoCache;

                    
        /**
        * Name: GebietNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT wahlvorschlag FROM Direktkandidat wahlvorschlag WHERE EXISTS(SELECT gruppeImGebiet FROM GruppeImGebiet gruppeImGebiet WHERE gruppeImGebiet.gebiet = ?1 AND gruppeImGebiet = wahlvorschlag.gruppeImGebiet)<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Direktkandidat> findByGebiet( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Direktkandidat.findByGebiet" ,  gebiet  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByGebiet( gebiet  ));
        }
        return (java.util.List<Direktkandidat>) cached;
        }
            return super.findByGebiet( gebiet  );
            }
                                        
        /**
        * Name: GruppeAndGebietNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT wahlvorschlag FROM Direktkandidat wahlvorschlag WHERE EXISTS (SELECT gruppeImGebiet FROM GruppeImGebiet gruppeImGebiet WHERE gruppeImGebiet = wahlvorschlag.gruppeImGebiet AND gruppeImGebiet.gruppe = ?1 AND gruppeImGebiet.gebiet = ?2)<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Direktkandidat> findByGruppeAndGebiet( @javax.annotation.Nonnull de.ivu.elect.business.gruppe.entity.Gruppe gruppe,  @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Direktkandidat.findByGruppeAndGebiet" ,  gruppe ,  gebiet  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByGruppeAndGebiet( gruppe ,  gebiet  ));
        }
        return (java.util.List<Direktkandidat>) cached;
        }
            return super.findByGruppeAndGebiet( gruppe ,  gebiet  );
            }
                                        
        /**
        * Name: WahlNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT wahlvorschlag FROM Direktkandidat wahlvorschlag WHERE EXISTS(SELECT gruppeImGebiet FROM GruppeImGebiet gruppeImGebiet WHERE gruppeImGebiet.gruppe.wahl = ?1 AND gruppeImGebiet = wahlvorschlag.gruppeImGebiet)<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Direktkandidat> findByWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Direktkandidat.findByWahl" ,  wahl  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByWahl( wahl  ));
        }
        return (java.util.List<Direktkandidat>) cached;
        }
            return super.findByWahl( wahl  );
            }
                    
@Override
public void clear() {
super.clear();
if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
daoCache.clear();
}

}

@Override
public void flush() {
super.flush();
if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
daoCache.clear();
}
}



}